VERSION 5.00
Begin VB.UserControl Title 
   Alignable       =   -1  'True
   Appearance      =   0  '2D
   BackStyle       =   0  'Transparent
   ClientHeight    =   525
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6690
   ControlContainer=   -1  'True
   HasDC           =   0   'False
   ScaleHeight     =   525
   ScaleWidth      =   6690
   Begin VB.CommandButton cmdClose 
      Height          =   255
      Left            =   6240
      MaskColor       =   &H00FF00FF&
      Picture         =   "Title.ctx":0000
      Style           =   1  'Grafisch
      TabIndex        =   2
      Top             =   120
      UseMaskColor    =   -1  'True
      Width           =   255
   End
   Begin VB.CommandButton cmdMenu 
      Height          =   255
      Left            =   120
      MaskColor       =   &H00FF00FF&
      Picture         =   "Title.ctx":011A
      Style           =   1  'Grafisch
      TabIndex        =   4
      Top             =   120
      UseMaskColor    =   -1  'True
      Width           =   255
   End
   Begin VB.CheckBox chkOnTop 
      Height          =   255
      Left            =   6000
      MaskColor       =   &H00FF00FF&
      Picture         =   "Title.ctx":0234
      Style           =   1  'Grafisch
      TabIndex        =   3
      Top             =   120
      UseMaskColor    =   -1  'True
      Width           =   255
   End
   Begin VB.PictureBox picBack 
      Appearance      =   0  '2D
      BackColor       =   &H80000002&
      BorderStyle     =   0  'Kein
      ForeColor       =   &H80000008&
      Height          =   315
      Left            =   780
      ScaleHeight     =   315
      ScaleWidth      =   4815
      TabIndex        =   0
      Top             =   120
      Width           =   4815
      Begin VB.Label lblTitle 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "Title"
         ForeColor       =   &H00FFFFFF&
         Height          =   195
         Left            =   180
         TabIndex        =   1
         Top             =   60
         Width           =   300
      End
   End
End
Attribute VB_Name = "Title"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Title user control made by Fox McCloud

'Use it as you wish, it's totally free!

'If you have any questions feel free to
'mail me at Fox_McCloud@gmx.net


'Enums
    Public Enum eTextAlign
        iLeft = 0
        iCenter = 1
        iRight = 2
    End Enum
    
'Types
    Private Type tRect
        X As Long
        Y As Long
        
        r As Long
        b As Long
    End Type
    
'Events
    Public Event Click(Button As Integer)
    Public Event MouseDown(X As Single, Y As Single, Button As Integer)
    Public Event MouseMove(X As Single, Y As Single, Button As Integer)
    Public Event MouseUp(X As Single, Y As Single, Button As Integer)
    
'Declares
    Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As tRect) As Long
    Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

'Variables
    Dim iCaption As String
    
    Dim iTextAlign As eTextAlign
    Dim iTextDistance As Long
    
    Dim iMoveParent As Boolean
    
    Dim iCloseEnabled As Boolean
    Dim iOnTopEnabled As Boolean
    Dim iMenuEnabled As Boolean
    
    'General
    Dim X2 As Long
    Dim Y2 As Long
    
    Dim LastButton As Integer
Sub Activate(iBackColor As Long, iForeColor As Long)
    'Active
    picBack.BackColor = iBackColor
    lblTitle.ForeColor = iForeColor
End Sub
Public Property Let Caption(nCaption As String)
    PropertyChanged "Caption"
    
    iCaption = nCaption
    
    UpdateCaption
End Property
Public Property Let MoveParent(nMoveParent As Boolean)
    PropertyChanged "MoveParent"
    
    iMoveParent = nMoveParent
End Property
Public Property Let OnTopEnabled(nOnTopEnabled As Boolean)
    PropertyChanged "OnTopEnabled"
    
    iOnTopEnabled = nOnTopEnabled
    
    UpdateSize
End Property
Public Property Let CloseEnabled(nCloseEnabled As Boolean)
    PropertyChanged "CloseEnabled"
    
    iCloseEnabled = nCloseEnabled
    
    UpdateSize
End Property
Public Property Let MenuEnabled(nMenuEnabled As Boolean)
    PropertyChanged "MenuEnabled"
    
    iMenuEnabled = nMenuEnabled
    
    UpdateSize
End Property
Sub SetOnTop(iOnTop As Boolean)
    chkOnTop.Value = IIf(iOnTop = True, 1, 0)
End Sub

Public Property Let TextDistance(nTextDistance As Long)
    PropertyChanged "TextDistance"
    
    iTextDistance = nTextDistance
    
    UpdateSize
End Property

Public Property Let TextAlign(nTextAlign As eTextAlign)
    PropertyChanged "TextAlign"
    
    iTextAlign = nTextAlign
    
    UpdateSize
End Property

Public Property Get Caption() As String
    Caption = iCaption
End Property
Public Property Get MoveParent() As Boolean
    MoveParent = iMoveParent
End Property
Public Property Get OnTopEnabled() As Boolean
    OnTopEnabled = iOnTopEnabled
End Property
Public Property Get CloseEnabled() As Boolean
    CloseEnabled = iCloseEnabled
End Property
Public Property Get MenuEnabled() As Boolean
    MenuEnabled = iMenuEnabled
End Property
Public Property Get TextDistance() As Long
    TextDistance = iTextDistance
End Property
Public Property Get TextAlign() As eTextAlign
    TextAlign = iTextAlign
End Property
Sub Update()
    UpdateCaption
    UpdateSize
End Sub

Sub UpdateSize()
On Error Resume Next
    'Background
    picBack.Move (cmdMenu.Width * IIf(iMenuEnabled, 1, 0)), 0, UserControl.ScaleWidth - ((cmdClose.Width - Screen.TwipsPerPixelX) * IIf(iCloseEnabled, 1, 0)) - (chkOnTop.Width * IIf(iOnTopEnabled, 1, 0)) - (cmdMenu.Width * IIf(iMenuEnabled, 1, 0)), UserControl.ScaleHeight

    'Title
    If iTextAlign = iLeft Then
        lblTitle.Move TextDistance, (picBack.Height - lblTitle.Height) / 2
    ElseIf iTextAlign = iCenter Then
        lblTitle.Move (picBack.Width - lblTitle.Width) / 2, (picBack.Height - lblTitle.Height) / 2
    ElseIf iTextAlign = iRight Then
        lblTitle.Move picBack.Width - lblTitle.Width - TextDistance, (picBack.Height - lblTitle.Height) / 2
    End If
    
    'Buttons
    If iMenuEnabled Then: cmdMenu.Move 0, 0
    cmdMenu.Visible = iMenuEnabled
    
    If iCloseEnabled Then: cmdClose.Move UserControl.Width - cmdClose.Width, 0
    cmdClose.Visible = iCloseEnabled
    
    If iOnTopEnabled Then: chkOnTop.Move UserControl.Width - ((cmdClose.Width - Screen.TwipsPerPixelX) * IIf(iCloseEnabled, 1, 0)) - chkOnTop.Width, 0
    chkOnTop.Visible = iOnTopEnabled
End Sub

Private Sub chkOnTop_Click()
    PutOnTop IIf(chkOnTop.Value = 1, True, False)
    UserControl.Parent.ZOrder 0
End Sub

Private Sub cmdClose_Click()
On Error Resume Next
    
    PutOnTop False

    Unload UserControl.Parent
End Sub

Private Sub cmdMenu_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
On Error Resume Next
    
    UserControl.Parent.PopupMenu UserControl.Parent.mnuMenu
End Sub


Private Sub lblTitle_Click()
    UserControl_Click
End Sub

Private Sub lblTitle_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    UserControl_MouseDown Button, Shift, X, Y
End Sub


Private Sub lblTitle_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    UserControl_MouseMove Button, Shift, X, Y
End Sub
Private Sub lblTitle_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    UserControl_MouseUp Button, Shift, X, Y
End Sub


Private Sub picBack_Click()
    UserControl_Click
End Sub


Private Sub picBack_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    UserControl_MouseDown Button, Shift, X, Y
End Sub

Private Sub picBack_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    UserControl_MouseMove Button, Shift, X, Y
End Sub
Private Sub picBack_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    UserControl_MouseUp Button, Shift, X, Y
End Sub


Private Sub UserControl_Click()
    RaiseEvent Click(LastButton)
End Sub
Private Sub PutOnTop(iOnTop As Boolean)
    Dim Temp As tRect
    
    GetWindowRect UserControl.Parent.hwnd, Temp
    SetWindowPos UserControl.Parent.hwnd, IIf(iOnTop = True, -1, 1), Temp.X, Temp.Y, Temp.r - Temp.X, Temp.b - Temp.Y, &H40
End Sub

Private Sub UserControl_InitProperties()
    Caption = "Caption"
    TextAlign = iCenter
    TextDistance = 0
    
    MoveParent = True
    
    OnTopEnabled = True
    CloseEnabled = True
    MenuEnabled = True
    
    Update
End Sub

Sub UpdateCaption()
    If Not lblTitle.Caption = iCaption Then
        lblTitle.Caption = iCaption
        
        UpdateSize
    End If
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    X2 = X
    Y2 = Y
    
    LastButton = Button
    
    RaiseEvent MouseDown(X, Y, Button)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If MoveParent Then
        'Check Button
        If Button = 1 Then
            'Move parent
            With UserControl.Parent
                .Move .Left + (X - X2), .Top + (Y - Y2)
            End With
        End If
    End If
    
    RaiseEvent MouseMove(X, Y, Button)
End Sub


Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(X, Y, Button)
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    iCaption = PropBag.ReadProperty("Caption", "")
    iTextAlign = PropBag.ReadProperty("TextAlign", iCenter)
    iTextDistance = PropBag.ReadProperty("TextDistance", 0)
    
    iMoveParent = PropBag.ReadProperty("MoveParent", True)
    
    iOnTopEnabled = PropBag.ReadProperty("OnTopEnabled", True)
    iCloseEnabled = PropBag.ReadProperty("CloseEnabled", True)
    iMenuEnabled = PropBag.ReadProperty("MenuEnabled", True)

    Update
End Sub

Private Sub UserControl_Resize()
    UpdateSize
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "Caption", iCaption
    PropBag.WriteProperty "TextAlign", iTextAlign
    PropBag.WriteProperty "TextDistance", iTextDistance
    
    PropBag.WriteProperty "MoveParent", iMoveParent
    
    PropBag.WriteProperty "OnTopEnabled", iOnTopEnabled
    PropBag.WriteProperty "CloseEnabled", iCloseEnabled
    PropBag.WriteProperty "MenuEnabled", iMenuEnabled
End Sub


