VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "SMB editor"
   ClientHeight    =   4005
   ClientLeft      =   45
   ClientTop       =   615
   ClientWidth     =   4935
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   267
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   329
   Begin MSComDlg.CommonDialog Com1 
      Left            =   0
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.PictureBox picFront 
      BackColor       =   &H00FFFFFF&
      Height          =   3600
      Left            =   60
      MouseIcon       =   "frmMain.frx":1782
      MousePointer    =   99  'Benutzerdefiniert
      ScaleHeight     =   236
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   316
      TabIndex        =   0
      Top             =   60
      Width           =   4800
   End
   Begin VB.Label lblFPS 
      Caption         =   "FPS: 0"
      Height          =   195
      Left            =   3900
      TabIndex        =   2
      Top             =   3720
      Width           =   855
   End
   Begin VB.Label lblPosition 
      Caption         =   "Tile: 0, 0"
      Height          =   195
      Left            =   120
      TabIndex        =   1
      Top             =   3720
      Width           =   2715
   End
   Begin VB.Menu mnuFile 
      Caption         =   "File"
      Begin VB.Menu mnuLoad 
         Caption         =   "Load level"
      End
      Begin VB.Menu mnuSave 
         Caption         =   "Save level"
      End
      Begin VB.Menu mnuLine2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuRun 
         Caption         =   "Run"
      End
      Begin VB.Menu mnuLine1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "Exit"
      End
   End
   Begin VB.Menu mnuEditor 
      Caption         =   "Editor"
      Begin VB.Menu mnuImport 
         Caption         =   "Import ASCII level"
      End
      Begin VB.Menu mnuExport 
         Caption         =   "Export ASCII level"
      End
      Begin VB.Menu mnuLine3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuShowEditor 
         Caption         =   "Show editor"
      End
   End
   Begin VB.Menu mnuOptions 
      Caption         =   "Options"
      Begin VB.Menu mnuNoSound 
         Caption         =   "No Sound"
      End
      Begin VB.Menu mnuLine5 
         Caption         =   "-"
      End
      Begin VB.Menu mnuQ 
         Caption         =   "?"
         Begin VB.Menu mnuHelp 
            Caption         =   "Help"
         End
         Begin VB.Menu mnuLine4 
            Caption         =   "-"
         End
         Begin VB.Menu mnuAbout 
            Caption         =   "About..."
         End
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Variables
    Dim Cpt As String
Sub DoExportLevel()
    Dim Temp As String
    
    'Get a filename
    Com1.InitDir = LevelPath
    Com1.Filter = "*.txt|*.txt"
    Com1.ShowSave
    Temp = Com1.FileName
    
    'Load level
    If Not Temp = "" Then
        Caption = Cpt & " [Exporting]"
        Export LevelPath & GetLastPart(Temp, "\")
    End If
    
    Caption = Cpt
End Sub

Sub DoImportLevel()
    Dim Temp As String
    
    'Get a filename
    Com1.InitDir = LevelPath
    Com1.Filter = "*.txt|*.txt"
    Com1.ShowOpen
    Temp = Com1.FileName
    
    If Not Temp = "" Then
        Caption = Cpt & " [Importing]"
        
        'Load level
        Import LevelPath & GetLastPart(Temp, "\")
            
        With frmEdit
            'Apply GUI
            .txtName.Text = Level.Name
            .txtW.Text = Level.W
            .txtH.Text = Level.H
            
            .txtBackSpeed.Text = Level.BackSpeed
            .txtSkySpeed.Text = Level.SkySpeed
    
            .UpdateTiles
            .UpdateObjects
        End With
    End If
    
    Caption = Cpt
End Sub

Sub DoLoadLevel()
    Dim Temp As String
    
    'Get a filename
    Com1.InitDir = LevelPath
    Com1.Filter = "*.def|*.def"
    Com1.ShowOpen
    Temp = Com1.FileName
    
    If Not Temp = "" Then
        Caption = Cpt & " [Loading]"
        
        'Load level
        Load LevelPath & GetLastPart(Temp, "\")
        
        With frmEdit
            'Apply GUI
            .txtName.Text = Level.Name
            .txtW.Text = Level.W
            .txtH.Text = Level.H
            
            .txtBackSpeed.Text = Level.BackSpeed
            .txtSkySpeed.Text = Level.SkySpeed

            .UpdateTiles
            .UpdateObjects
        End With
        
        'Run loaded level
        mnuRun.Checked = True
        Caption = Cpt
        
        Game
    End If
End Sub

Sub DoSaveLevel()
    Dim Temp As String
    
    'Get a filename
    Com1.InitDir = LevelPath
    Com1.Filter = "*.def|*.def"
    Com1.ShowSave
    Temp = Com1.FileName
    
    'Load level
    If Not Temp = "" Then
        Caption = Cpt & " [Saving]"
        Save LevelPath & GetLastPart(Temp, "\")
    End If
    
    Caption = Cpt
End Sub

Private Sub Form_GotFocus()
    picFront.SetFocus
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    KD(KeyCode) = True
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
    KD(KeyCode) = False
End Sub


Private Sub Form_Load()
    'Variables
    Cpt = Me.Caption
    
    'Settings
    Settings.GetObjectPos frmEdit
    Settings.GetObjectPos frmPreview
    
    'Show windows
    frmEdit.Show
    frmPreview.Show
    frmPreview.Title.SetOnTop True
    
    mDXGraphics.Initialize
    mDXGraphics.InitWindowed frmMain.picFront.hWnd
    
    mDSound.Initialize
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Settings.SetObjectPos Me
    
    Unload frmEdit
    Unload frmPreview
    
    ExitProgram
End Sub

Private Sub mnuAbout_Click()
    Settings.GetObjectPos frmAbout
    frmAbout.Show
    frmAbout.Title.SetOnTop True
    frmAbout.ShowCredits
End Sub

Private Sub mnuExit_Click()
    Unload Me
End Sub

Private Sub mnuExport_Click()
    DoExportLevel
End Sub

Private Sub mnuHelp_Click()
    Settings.GetObjectPos frmHelp
    frmHelp.Show
End Sub

Private Sub mnuImport_Click()
    DoImportLevel
End Sub

Private Sub mnuLoad_Click()
    DoLoadLevel
End Sub

Private Sub mnuNoSound_Click()
    mnuNoSound.Checked = Not mnuNoSound.Checked
    
    NoSound = mnuNoSound.Checked
End Sub

Private Sub mnuRun_Click()
    mnuRun.Checked = Not mnuRun.Checked

    If Level.Name = "" Then
        'No level loaded
        mnuRun.Checked = False
        DoLoadLevel
        
    Else
        If mnuRun.Checked = True Then
            'Run game
            Game
            
        Else
            'Stop game
            Active = False
        End If
    End If
End Sub

Private Sub mnuSave_Click()
    DoSaveLevel
End Sub


Private Sub mnuShowEditor_Click()
    'Show editor
    frmEdit.Show
End Sub

Private Sub picFront_KeyDown(KeyCode As Integer, Shift As Integer)
    KD(KeyCode) = True
End Sub

Private Sub picFront_KeyUp(KeyCode As Integer, Shift As Integer)
    KD(KeyCode) = False
End Sub


Private Sub picFront_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Call picFront_MouseMove(Button, Shift, x, y)
End Sub

Private Sub picFront_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
On Error Resume Next
    
    Dim Temp As String
    
    If Button > 0 Then
        Select Case EditorMode
        Case cEditTiles
            Select Case frmEdit.cmbLayer.ListIndex
            Case 0
                Level.Sky(Int((y + (Camera.y / Level.SkySpeed)) / TileH) * Level.W + Int((x + (Camera.x / Level.SkySpeed)) / TileW)) = IIf(Button = 1, ActTile, 0)
            Case 1
                Level.Back(Int((y + (Camera.y / Level.BackSpeed)) / TileH) * Level.W + Int((x + (Camera.x / Level.BackSpeed)) / TileW)) = IIf(Button = 1, ActTile, 0)
            Case 2
                Level.Floor(Int((y + Camera.y) / TileH) * Level.W + Int((x + Camera.x) / TileW)) = IIf(Button = 1, ActTile, 0)
            End Select
            
        Case cEditObjects
            Level.Object(Int((y + Camera.y) / TileH) * Level.W + Int((x + Camera.x) / TileW)) = IIf(Button = 1, ActObject, 0)
        End Select
    End If
    
    'Mouse position
    Mouse.x = x
    Mouse.y = y
    
    'Position label
    Temp = "Tile: " & Int((Camera.x + Mouse.x) / TileW) & ", " & Int((Camera.y + Mouse.y) / TileH) & " [" & Level.Sky(Int((y + (Camera.y / Level.SkySpeed)) / TileH) * Level.W + Int((x + (Camera.x / Level.SkySpeed)) / TileW)) & ", " & Level.Back(Int((y + (Camera.y / Level.BackSpeed)) / TileH) * Level.W + Int((x + (Camera.x / Level.BackSpeed)) / TileW)) & ", " & Level.Floor(Int((y + Camera.y) / TileH) * Level.W + Int((x + Camera.x) / TileW)) & "]"
    If Not lblPosition.Caption = Temp Then: lblPosition.Caption = Temp
End Sub
