Attribute VB_Name = "mAnimation"
Option Explicit

'Types
    Type tAnimation
        Enabled As Boolean
        
        Speed As Long
        LastTick As Long
        
        MaxX As Long
        MaxY As Long
        
        ActX As Long
        ActY As Long
    End Type
    
'Declares
    Public Declare Function GetTickCount Lib "kernel32" () As Long

Sub Animate(iAnimation As tAnimation)
    Dim Temp As Long
    
    Temp = GetTickCount
    
    With iAnimation
        If .Enabled Then
            'Animation active
            If .LastTick + .Speed <= Temp Then
                'Animate
                .LastTick = Temp
        
                'Check position
                .ActX = .ActX + 1
                If .ActX > .MaxX Then
                    .ActX = 0
                    .ActY = .ActY + 1
                    If .ActY > .MaxY Then: .ActY = 0
                End If
            End If
        End If
    End With
End Sub

